       
            function getUrlVars(params)
            {
                var returnArray = [];
                
                params.forEach(function(entry){
                    var tempVar = entry.split('=');
                    returnArray[tempVar[0]] = tempVar[1];
                });
                
                return returnArray;
            }
            
            function urlVarsToString(varArray)
            {
                var returnString = '';
                passcount = 0;
                for (var k in varArray){
                    
                    if (varArray.hasOwnProperty(k)) {
                        if (passcount < 1) {
                            var seperatorParameter = '?';
                        }
                        else
                        {
                            var seperatorParameter = '&';
                        }
                        
                        returnString += seperatorParameter + k + '=' + varArray[k];
                    }
                    passcount++;
                }
                return returnString;
            }
            
            function urlVarsToStringCleaned(varArray)
            {
                var returnString = '';
                passcount = 0;
                for (var k in varArray){
                    
                    if (varArray.hasOwnProperty(k)) {
                        if (passcount < 1) {
                            var seperatorParameter = '?';
                        }
                        else
                        {
                            var seperatorParameter = '&';
                        }
                        
                        if ((varArray[k].indexOf('school_level') > -1) || (varArray[k].indexOf('school_grade') > -1) || (varArray[k].indexOf('school_discipline') > -1) || (varArray[k].indexOf('school_topic') > -1) || (varArray[k].indexOf('school_subtopic') > -1) || (varArray[k].indexOf('resource_language') > -1) || (varArray[k].indexOf('resource_type') > -1)) {
    
                        }
                        else
                        {
                            
                            returnString += seperatorParameter + varArray[k];
                            passcount++;
                        }
                    }
                    
                }
                return returnString;
            }
            
            function turnOnRelevantLimitInDropDown(varArray)
            {
                if (varArray.hasOwnProperty('limit')) 
                {
                    var value = varArray['limit'];
                    var els = document.getElementsByClassName('ri_select');
                    jQuery(els).val(value);  
                }
                else
                {
                    var els = document.getElementsByClassName('ri_select');
                    jQuery(els).val('10');
                }
            }
            
            function turnOnRelevantSortTab(varArray)
            {
                if (varArray.hasOwnProperty('sort')) 
                {
                    var el = document.getElementById('mostrecent'); 
                    jQuery(el).addClass('active'); 
                    var el = document.getElementById('relevance'); 
                    jQuery(el).removeClass('active'); 
                }
                else
                {
                    var el = document.getElementById('mostrecent'); 
                    jQuery(el).removeClass('active'); 
                    var el = document.getElementById('relevance'); 
                    jQuery(el).addClass('active');
                }
            }

            function turnOnCheckboxesFromParameter(varArray)
            {
                for (var k in varArray)
                {
                    if (varArray.hasOwnProperty(k)) 
                    {
                        var values = varArray[k].split(',');
                        values.forEach( function(entry){
                            var el = document.getElementById('' + k + '~' + entry); 
                            jQuery(el).attr('checked', true);
                        });
                    }
                }
            }
            
            function turnOnOffShowFiltersPanel(varArray)
            {
                
                var showFilterPanel = false;
                for (var k in varArray)
                {
                    if (varArray.hasOwnProperty(k)) 
                    {
                        if ((k.indexOf('school_level') > -1) || (k.indexOf('school_grade') > -1) || (k.indexOf('school_discipline') > -1) || (k.indexOf('school_topic') > -1) || (k.indexOf('school_subtopic') > -1) || (k.indexOf('resource_language') > -1) || (k.indexOf('resource_type') > -1)) 
                        {
                            showFilterPanel = true;
                        }
                    }
                }
                
                if (showFilterPanel) 
                {
                    var els = document.getElementsByClassName('f_clearfilters_panel'); 
                    jQuery(els).show();   
                }
                else
                {
                    var els = document.getElementsByClassName('f_clearfilters_panel'); 
                    jQuery(els).hide();  
                }
            }
            
            function makedActiveAllTabsWithGivenCounterClasses()
            {
                var els = document.getElementsByClassName('counter0');
                jQuery(els).removeClass("is_closed");
                jQuery(els).addClass("is_open");
                
                jQuery(els).each(function (){
                    jQuery(this).find(".sc-caret-down").removeClass("sr_hide").addClass('sr_show');
                    jQuery(this).find(".sc-caret-right").removeClass("sr_show").addClass('sr_hide');
                });
            }
            
            function activateThisTab(el, tabId)
            {
                // mark inactive all parent/child items
                jQuery(el).parent().parent().children("dd").each(function (){
                    jQuery(this).removeClass("active");
                });
                
                // mark this one active
                jQuery(el).parent().addClass("active");
                
                //mark hidden all parent/child tabs
                jQuery(el).parent().parent().parent().parent().find(".content").each(function (){
                    jQuery(this).removeClass("active");
                });
                
                // mark this one shown!
                var el = document.getElementById(tabId);
                jQuery(el).addClass("active");
            }
            
            function rearrangeSubjectLevelIndicators()
            {
                var els = document.getElementsByClassName('rhsTabs');
                jQuery(els).each(function (){
                    var subjectSpan = jQuery(this).children().first().clone();
                    jQuery(this).children().first().remove();
                    jQuery(this).append(subjectSpan);
                });
            }
            
            function removeA(arr) {
                var what, a = arguments, L = a.length, ax;
                while (L > 1 && arr.length) {
                    what = a[--L];
                    while ((ax= arr.indexOf(what)) !== -1) {
                        arr.splice(ax, 1);
                    }
                }
                return arr;
            }
            
            function removeParameterFromArray(arrayToRemoveFrom, valueToRemove)
            {
                var modifiedArray = [];
                
                if (arrayToRemoveFrom.hasOwnProperty(valueToRemove[0])) 
                {
                    if (arrayToRemoveFrom[valueToRemove[0]].indexOf(',') > -1) {
                        var tempArray = arrayToRemoveFrom[valueToRemove[0]].split(',');

                        removeA(tempArray, valueToRemove[1]);

                        var passcount = 0;
                        var tempString = '';
                        for (var k in tempArray)
                        {
                            if (passcount < 1) 
                            {
                                tempString += tempArray[k];
                            }
                            else
                            {
                                tempString += ',' + tempArray[k];
                            }
                            passcount++;
                        }
                        
                        arrayToRemoveFrom[valueToRemove[0]] = tempString;
                    }
                    else
                    {
                        delete arrayToRemoveFrom[valueToRemove[0]];
                    }
                    
                    modifiedArray = arrayToRemoveFrom;
                }
                
                return modifiedArray;
            }
            
            function showMore(item)
            {
                var itemClassContains = jQuery('.' + item);
                itemClassContains.toggle();
            }
            
            function clearFilters()
            {
                try {     
                    var parameters = window.location.search.split('?')[1].split('&');
                }
                catch(err) {
                    var parameters = [];
                }
               
                updatedParams = urlVarsToStringCleaned(parameters);
                var newstring = window.location.protocol + '//' + window.location.hostname + window.location.pathname + updatedParams;
                document.location.href=newstring;
            }
            
            function sort(sortType)
            {
                try {     
                    var parameters = window.location.search.split('?')[1].split('&');
                }
                catch(err) {
                    var parameters = [];
                }
                
                var parametersArray = getUrlVars(parameters);
                var doRedirect = false;
                 
                if (parametersArray.hasOwnProperty('sort')) 
                {
                    if (parametersArray['sort'] != sortType) 
                    {
                        if (sortType == '') 
                        {
                            delete parametersArray['sort'];
                        }
                        else
                        {
                            parametersArray['sort'] = sortType
                        }
                        doRedirect = true;
                    }
                }
                else
                {
                    parametersArray['sort'] = sortType;
                    doRedirect = true;
                }
                
                updatedParams = urlVarsToString(parametersArray);
                var newstring = window.location.protocol + '//' + window.location.hostname + window.location.pathname + updatedParams;
                if(doRedirect)
                {
                    document.location.href=newstring;
                }
            }

            jQuery(document).ready(function($) {
            
                jQuery('.r_fulldescription').toggle();
                
                //jQuery('.tabs-content').hide();
                
                try {     
                    var parameters = window.location.search.split('?')[1].split('&');
                }
                catch(err) {
                    var parameters = [];
                }

                var parametersArray = getUrlVars(parameters);
                
                turnOnCheckboxesFromParameter(parametersArray);
                
                turnOnRelevantSortTab(parametersArray);
                
                turnOnRelevantLimitInDropDown(parametersArray);
                
                turnOnOffShowFiltersPanel(parametersArray);
                
                makedActiveAllTabsWithGivenCounterClasses();
                
                rearrangeSubjectLevelIndicators();

                $('#facet_school_topic').hide();
                $('.fieldset_school_topic').find('.icon').toggle();
                $('#facet_school_subtopic').hide();
                $('.fieldset_school_subtopic').find('.icon').toggle();

                $('.f_fieldset').on('click','.f_title', function(e){
                    e.preventDefault();
                    var item = $(this).closest('.f_fieldset');
                    $(this).find('.icon').toggle();
                    item.find('.f_list').toggle();
                });

                //Open full description
                $('.resource').on('click', '.r_viewfull-button', function(e) {        
                    e.preventDefault();
                    $(this).hide();                
                });

                $('.resource').on('click', '.r_closefull-button', function(e) {
                    var item = $(this).closest('.resource');
                    e.preventDefault();
                    item.find('.r_viewfull-button').show();
                });
    

                //Close Curriculum accordion
                $('.r_fullcurriculum').on('click','.sc-caret-down', function(e){
                    e.preventDefault();
                    var item = $(this).closest('.r-curr-item');

                    item.removeClass('is_open').addClass('is_closed');
                    item.find('.sc-caret-right').removeClass('sr_hide').addClass('sr_show');
                    item.find('.sc-caret-down').removeClass('sr_show').addClass('sr_hide');
                });

                //Open Curriculum accordion
                $('.r_fullcurriculum').on('click','.sc-caret-right', function(e){
                    e.preventDefault();
                    var item = $(this).closest('.r-curr-item');
                    item.addClass('is_open').removeClass('is_closed');
                    item.find('.sc-caret-down').removeClass('sr_hide').addClass('sr_show');
                    item.find('.sc-caret-right').removeClass('sr_show').addClass('sr_hide');
                });
                   

                $('.ri_select').change(
                    function(){
                        var sortType = $(this).val();
                        var doRedirect = false;
                 
                        if (parametersArray.hasOwnProperty('limit')) 
                        {
                            if (parametersArray['limit'] != sortType) 
                            {
                                if ((sortType == '') || (sortType == '10')) // 10 = default!  
                                {
                                    delete parametersArray['limit'];
                                }
                                else
                                {
                                    parametersArray['limit'] = sortType
                                }
                                doRedirect = true;
                            }
                        }
                        else
                        {
                            if (sortType == '10') // 10 = default! 
                            {
                                doRedirect = false;
                            }
                            else
                            {
                                parametersArray['limit'] = sortType;
                                doRedirect = true;
                            }
                        }

                        updatedParams = urlVarsToString(parametersArray);
                        var newstring = window.location.protocol + '//' + window.location.hostname + window.location.pathname + updatedParams;
                        if(doRedirect)
                        {
                            document.location.href=newstring;
                        }
                });

                $('input:checkbox').change(
                    function(){
                        var updatedParams = '';
                        
                        if ($(this).is(':checked')) {
                            var keyValuePair = this.name.split('~');
                            
                            if (parametersArray.hasOwnProperty(keyValuePair[0])) {
                                parametersArray[keyValuePair[0]] += ',' + keyValuePair[1];
                            }
                            else
                            {
                                parametersArray[keyValuePair[0]] = keyValuePair[1];
                            }
                            
                            updatedParams = urlVarsToString(parametersArray);
                            var newstring = window.location.protocol + '//' + window.location.hostname + window.location.pathname + updatedParams;
                            document.location.href=newstring;
                        }
                        else
                        {
                            var keyValuePair = this.name.split('~');
                            parametersArray = removeParameterFromArray(parametersArray, keyValuePair);                           
                            updatedParams = urlVarsToString(parametersArray);
                            var newstring = window.location.protocol + '//' + window.location.hostname + window.location.pathname + updatedParams;
                            document.location.href=newstring;
                        }
                    });
                });