<?php

define('scoilnetResources_URL', plugin_dir_url(__FILE__));

/**
 * Description of resultsTemplate
 *
 * @author Admin
 */
class resultsTemplate {

    protected $js = "<script></script>";
    protected $wrapperTemplate = "
        <div class=\"sr_wrapper\">
            [SEARCHBOX]
            <div class=\"sr_row\">
                <div class=\"sr-12 sr_columns\">
                    <div class=\"sr_copyright\"><small>resources by <a href=\"https://www.scoilnet.ie\"><img src=\"[SCOILNETIMAGE]\" width=\"84\" height=\"16\" /></a></small></div>
                    <!-- Search results for 'TODO!' -->
                </div>
            </div>
            
            <div class=\"sr_row\">
                <div class=\"results_info\">
                    <div class=\"sr-3 sr_columns\">
                        <small class=\"r_count\">[NUMBEROFRESULTS] results</small>|
                        <small>
                            <select class=\"ri_select\">
                                <option>10</option>
                                <option>25</option>
                                <option>50</option>
                            </select>per page</small>                    
                    </div>
                    <div class=\"sr-9 sr_columns\">
                        [PAGINATION]
                        <dl class=\"sr_tabs sr_best-filters\">
                            <dd id=\"relevance\"><a onclick=\"sort('');return false;\">Best Match</a>
                            </dd>
                            <dd id=\"mostrecent\"><a onclick=\"sort('creation_date');return false;\">Most Recent</a>
                            </dd>                        
                        </dl>
                    </div>
                </div>
            </div>
            

            <div class=\"sr_list_of_resources\">
                <div class=\"sr_row\">
                    <div class=\"sr-3 sr_columns\">
                            <div class=\"sr_filters\">
                                <div class=\"f_block_title\">Narrow your results</div>
                                <div class=\"panel f_clearfilters_panel\">
                                    <a class=\"f_clearfilters\" onclick=\"clearFilters();return false;\">Clear selected filters</a>
                                </div>
                                [FILTERS]
                                </div>
                    </div>
                    <div class=\"sr-9 sr_columns\">
                        <div class=\"list-of-resources\">
                        [RESOURCES]
                        </div>
                    </div>
                </div>
            </div>
            

            <div class=\"sr_row\">
                <div class=\"results_info\">
                    <div class=\"sr-3 sr_columns\">
                        <small class=\"r_count\">[NUMBEROFRESULTS] results</small>|
                        <small>
                            <select class=\"ri_select\">
                                <option>10</option>
                                <option>25</option>
                                <option>50</option>
                            </select>per page</small>
                    </div>
                    <div class=\"sr-9 sr_columns\">
                        [PAGINATION]
                    </div>
                </div>
            </div>
        </div>
            ";
    protected $ResultItemTemplate = "        
                                    <div class=\"resource\">    
                                        <div class=\"sr_row\">
                                            <div class=\"sr-8 sr_columns\">
                                                <div class=\"r_text\">
                                                    <span class=\"r_format_[RES-FORMAT-ID] r_format\"></span>
                                                    <div class=\"r_title\"><a href=\"[RES-URL]\" target=\"_blank\">[RES-TITLE]</a></div>
                                                    <small class=\"r_url\"><a href=\"[RES-URL]\" target=\"_blank\">[RES-RENDEREDURL]</a></small>
                                                    <small class=\"r_date\">Added:[RES-CREATIONDATE]</small>
                                                    <small class=\"r_author\">Contributor: <a class=\"r_author_link\" href=\"\">[RES-AUTHOR]</a>
                                                    </small>
                                                    <small class=\"r_type\"><span class=\"r_term\">Resource type:</span> [RES-TYPE]</small>
                                                    <div class=\"r_excerpt\">[RES-DESCRIPTION]</div>
                                                    <a onclick=\"showMore('item[ITEMID]');return false;\" class=\"r_viewfull-button\">View full description <span class=\"icon sc-caret-down\"></span></a>
                                                </div>
                                            </div>
                                            <div class=\"sr-4 sr_columns\">
                                                <div class=\"r_meta\">
                                                    <div class=\"r_rating\">
                                                        [RES-RATING]
                                                    </div>                                      
                                                    <div class=\"r_curriculum curr_compact\">
                                                        [RES-CURR]
                                                    </div>                                                    
                                                </div>
                                            </div> 
                                        </div>
                                        <div class=\"sr_row r_fulldescription item[ITEMID] \">
                                            <div class=\"sr-8 sr_columns\">
                                                <div class=\"r_fullcurriculum\">
                                                    <div class=\"r_curriculum\">
                                                        <div class=\"r_curr-heading\">How it maps to the curriculum</div>
                                                        [HOWITMAPS] 
                                                    </div>
                                                </div>
                                            </div>    
                                            <div class=\"sr-4 sr_columns\">
                                                <!-- FR TODO :: awaiting response
                                                <div class=\"r_thumb\">
                                                    <img src=\"http://lorempixel.com/300/250/technics\" />
                                                </div>
                                                -->
                                                <div class=\"r_meta\">
                                                    <div class=\"r_asset r_meta_item\">
                                                        <span class=\"r_term\">Asset type:</span>&nbsp;[META-TYPE]
                                                    </div>
                                                    <div class=\"r_language r_meta_item\">
                                                        <span class=\"r_term\">Language:</span>&nbsp;[META-LANG]
                                                    </div>
                                                    <!-- FR TODO :: move to new location and display in curriculum - see notes below regarding SEN also!
                                                    <div class=\"r_keyskills r_meta_item\">
                                                        <span class=\"r_term\">Key Skills:</span>&nbsp;[META-SKILLS]
                                                    </div>
                                                    -->
                                                    <div class=\"r_rights r_meta_item\">
                                                        <span class=\"r_term\">Rights:</span>&nbsp;[META-RIGHTS]
                                                    </div>
                                                </div>
                                            </div>
                                            <div class=\"sr-12 sr_columns\">
                                                <a onclick=\"showMore('item[ITEMID]');return false;\" class=\"r_closefull-button\">Close full description <span class=\"icon sc-caret-up\"></span></a>
                                            </div>
                                        </div>
                                    </div>
                                                        
                                ";
    protected $curriculumTemplate = "
                                                    [CUR]
                                                ";
    protected $TabsTemplate = "[MAPS]";
    protected $curriculumTemplateSubject = "<div class=\"r-curr-item rhsTabs\" ><span title=\"Subject\" class=\"curr_subject\">[SUBJECT]</span>";
    protected $curriculumTemplateLevel = "<span title=\"[LEVELTITLE]\" class=\"curr_level curr_[LEVELCODE]\">[LEVELCODE]</span>";
    protected $howItMaps = "<!-- LOOP HERE FOR SUBJECTS -->
                                                    <div class=\"r-curr-item counter[COUNTER] is_closed\">
                                                        <div class=\"r_accordion_header \">
                                                            <span class=\"icon sc-caret-down sr_hide\" title=\"Hide\"></span>
                                                            <span class=\"icon sc-caret-right\" title=\"Show\"></span>
                                                            
                                                            <!-- LOOP HERE FOR CLASSES -->
                                                            <dl class=\"tabs\" data-tab>
                                                                [LEVELS]
                                                                <dd>
                                                                    <span title=\"Subject\" class=\"curr_subject\">[TABS-SUBJECT]</span>
                                                                </dd>
                                                            </dl>
                                                            <!-- END - LOOP HERE FOR CLASSES -->
                                                            
                                                        </div>
                                                        <div class=\"tabs-content\">
                                                            <!-- resdet start -->
                                                            [RESOURCEDETAILS]
                                                            <!-- resdet end -->
                                                        </div>  
                                                    </div>
                                                <!-- END - LOOP HERE FOR SUBJECTS -->";
    protected $howItMapsLevelsTemplate = "<dd class=\"[TABCLASS]\">
                                            <a onclick=\"activateThisTab(this,'panel[COUNTER]-[SUBJECTCOUNTER]-[LEVELCOUNTERCOUNTER]'); return false;\">
                                            <span title=\"[LEVELTITLE]\" class=\"curr_level curr_[LEVELCODE]\">[LEVELCODE]</span>
                                            </a>
                                        </dd>
                                        ";
    protected $detailsTabs = "";

    function friendlyName($unfriendlyString) {
        $alpha = "";
        switch ($unfriendlyString) {
            case "school_level":
                $alpha = "Level";
                break;
            case "school_grade":
                $alpha = "Grade";
                break;
            case "school_discipline":
                $alpha = "Subject";
                break;
            case "school_topic":
                $alpha = "Strand / Section";
                break;
            case "school_subtopic":
                $alpha = "Strand Unit";
                break;
            case "resource_language":
                $alpha = "Language";
                break;
            case "resource_type":
                $alpha = "Resource Type";
                break;
        }
        return $alpha;
    }

    public function processFacetValues($val) {
        $output = "";
        foreach ($val as $FacetsEntity) {
            if ((is_array($FacetsEntity['entity'])) && (array_key_exists('title', $FacetsEntity['entity']))) {
                $output .= "<li><label class=\"f_label\">"
                        . "<input type=\"checkbox\" id=\"" . $FacetsEntity['facetKey'] . "~" . $FacetsEntity['entity']['id'] . "\" name=\"" . $FacetsEntity['facetKey'] . "~" . $FacetsEntity['entity']['id'] . "\" class=\"f_checkbox\">"
                        . $FacetsEntity['entity']['title']
                        . "&nbsp;<span class=\"f_count\">(" . $FacetsEntity['count'] . ")</span>"
                        . "</label></li>";
            }
        }
        return $output;
    }

    //put your code here
    public function displayResults($resultsAsJson, $wiredParams) {
        if ($resultsAsJson && ($resultsAsJson['success'] == TRUE) && ($resultsAsJson['totalResults'] > 0)) {
            echo $this->js;
            $success = $resultsAsJson['success'];
            $totalResults = $resultsAsJson['totalResults'];
            $Results = $resultsAsJson['results'];
            $Facets = $resultsAsJson['facets'];
            $facetsOutput = "";
            $facetKey = "";

            while ($alphaA = current($Facets)) {
                if ($wiredParams[key($Facets)]) {
                    next($Facets);
                } else {
                    $facetsOutput .= "<fieldset class=\"f_fieldset fieldset_" . key($Facets) . "\">
                                        <div class=\"f_title\">
                                        <span class=\"icon sc-caret-down\"></span>
                                        <span class=\"icon sc-caret-right sr_hide\"></span>" . $this->friendlyName(key($Facets)) . "</div>";

                    $facetsOutput .= "<ul class=\"f_list\" id=\"facet_" . key($Facets) . "\">";
                    $facetsOutput .= $this->processFacetValues($alphaA);
                    $facetsOutput .= "</ul>
                                        </fieldset>";
                    next($Facets);
                }
            }

            $thisPagesSize = count($Results);
            $resultsPerPage = $resultsAsJson['limit'];
            $ResultItemOutput = "";
            $loopCount = 0;

            foreach ($Results as $ResultItem) {
                $output = "";
                $output = str_replace("[RES-TITLE]", $ResultItem['title'], $this->ResultItemTemplate);
                $output = str_replace("[RES-CREATIONDATE]", date("j M Y", $ResultItem['creation_date']), $output);
                $output = str_replace("[RES-AUTHOR]", $ResultItem['author'], $output);
                $output = str_replace("[RES-DESCRIPTION]", nl2br($ResultItem['description']), $output);
                $output = str_replace("[RES-URL]", $this->getFirst($ResultItem['urls']), $output);
                $output = str_replace("[RES-RENDEREDURL]", $this->renderLongUrl($this->getFirst($ResultItem['urls'])), $output);
                $output = str_replace("[RES-FORMAT-ID]", $ResultItem['format']['id'], $output);

                $output = str_replace("[RES-TYPE]", $this->getAsCommaDelimited($ResultItem['types']), $output);
                $processCurric = $this->getCurriculum($ResultItem['curriculum'], $loopCount);
                $output = str_replace("[RES-CURR]", $processCurric[0], $output);
                $output = str_replace("[HOWITMAPS]", $processCurric[1], $output);
                $output = str_replace("[RES-RATING]", $this->ratingToStars($ResultItem['rating']), $output);
                $output = str_replace("[META-TYPE]", $this->getAsCommaDelimited($ResultItem['types']), $output);
                $output = str_replace("[META-LANG]", $this->getAsCommaDelimited($ResultItem['languages']), $output);
                //// awaiting desging and location for "key skills" and "SEN" - both seem to be linked to curruculum
                //// $output = str_replace("[META-SKILLS]", $this->getAsCommaDelimited($ResultItem['curriculum']),$output );
                $output = str_replace("[META-RIGHTS]", $this->getAsCommaDelimited($ResultItem['rights']), $output);
                $output = str_replace("[ITEMID]", $loopCount, $output);

                $loopCount++;

                $ResultItemOutput .= $output;
            }
            $overAllOutput = str_replace("[FILTERS]", $facetsOutput, $this->wrapperTemplate);
            $overAllOutput = str_replace("[SCOILNETIMAGE]", scoilnetResources_URL . "images/scoilnet-tiny-logo.png", $overAllOutput);
            $overAllOutput = str_replace("[RESOURCES]", $ResultItemOutput, $overAllOutput);
            $overAllOutput = str_replace("[NUMBEROFRESULTS]", $totalResults, $overAllOutput);
            $overAllOutput = str_replace("[SEARCHBOX]", the_widget('scoilnetResources_SearchBoxWidget'), $overAllOutput);

            $params = $_GET;
            $page = $params[$this->pageIdentifier]? : 1;
            $overAllOutput = str_replace("[PAGINATION]", $this->paginationFilter($totalResults, $page, $resultsPerPage), $overAllOutput);
            echo $overAllOutput;
        } else {
            echo the_widget('scoilnetResources_SearchBoxWidget');
            echo "<div class=\"sr_wrapper\"><div class=\"sr_row\"><div class=\"sr-12 sr_columns\"><div class=\"sr_copyright\"><small>resources by <a href=\"http://www.scoilnet.ie\"><img src=\"" . scoilnetResources_URL . "images/scoilnet-tiny-logo.png\" width=\"84\" height=\"16\" /></a></small></div> <p>No results match your search criteria</p></div></div></div>";
        }
    }

    function ratingToStars($ratingValue) {
        if ($ratingValue >= 0) {
            $responseString = "<div class=\"r_rating\" title=\"Star rating\">";

            for ($i = 0; $i < $ratingValue; $i++) {
                $responseString .= "<img src=\"" . scoilnetResources_URL . "images/star-on.svg\" alt=\"" . $i . "\" title=\"Star rating\">&nbsp;";
            }
            for ($i = 0; $i < 5 - $ratingValue; $i++) {
                $responseString .= "<img src=\"" . scoilnetResources_URL . "images/star-off.svg\" alt=\"" . $i . "\" title=\"Star rating\">&nbsp;";
            }

            return $responseString .= "</div>";
        } else {
            return "";
        }
    }

    function getFirst($array) {
        if (is_array($array)) {
            return $array[0];
        }
    }

    function getAsCommaDelimited($array) {
        $returnString = "";
        if (is_array($array)) {
            foreach ($array as $value) {
                if ((is_array($value)) && (array_key_exists('title', $value))) {
                    $returnString .= $value['title'] . ", ";
                }
            }
        }
        if (strlen($returnString) > 2) {
            return substr($returnString, 0, -2);
        } else {
            return "";
        }
    }

    function renderLongUrl($url) {
        if (strlen($url) > 70) {
            $url1 = substr($url, 0, 35);
            $url2 = substr($url, -35);
            return $url1 . '...' . $url2;
        } else {
            return $url;
        }
    }

    function getCurriculum($array, $_loopCount) {
        $returnString = "";

        if (is_array($array)) {
            $sortedArray = $this->groupCurriculumByGradeAndDiscipline($array);
            $SUBJECTCOUNTER = 0;

            foreach ($sortedArray as $value) {
                $returnString .= str_replace("[SUBJECT]", $value['subject']['title'], $this->curriculumTemplateSubject);
                $returnStringTabs .=str_replace("[TABS-SUBJECT]", $value['subject']['title'], $this->howItMaps);
                $returnStringTabs = str_replace("[COUNTER]", $SUBJECTCOUNTER, $returnStringTabs);
                $returnStringGradeArray = "";
                $returnStringGradeArrayTabs = "";
                $LEVELCOUNTERCOUNTER = 0;

                foreach ($value['grade'] as $gradeArray) {
                    $returnStringInner = str_replace("[LEVELTITLE]", $gradeArray['title'], $this->curriculumTemplateLevel);
                    $returnStringInner = str_replace("[LEVELCODE]", $gradeArray['abbr'], $returnStringInner);

                    $returnStringInnerTabs = str_replace("[LEVELTITLE]", $gradeArray['title'], $this->howItMapsLevelsTemplate);
                    $returnStringInnerTabs = str_replace("[COUNTER]", $_loopCount, $returnStringInnerTabs);
                    $returnStringInnerTabs = str_replace("[LEVELCODE]", $gradeArray['abbr'], $returnStringInnerTabs);

                    if ($LEVELCOUNTERCOUNTER == 0) {
                        $returnStringInnerTabs = str_replace("[TABCLASS]", "active", $returnStringInnerTabs);
                    } else {
                        $returnStringInnerTabs = str_replace("[TABCLASS]", "", $returnStringInnerTabs);
                    }

                    $returnStringInnerTabs = str_replace("[SUBJECTCOUNTER]", $SUBJECTCOUNTER, $returnStringInnerTabs);
                    $returnStringInnerTabs = str_replace("[LEVELCOUNTERCOUNTER]", $LEVELCOUNTERCOUNTER, $returnStringInnerTabs);
                    $returnStringGradeArray .= $returnStringInner;
                    $returnStringGradeArrayTabs .= $returnStringInnerTabs;
                    $LEVELCOUNTERCOUNTER++;
                }

                $detailsOut = "";
                $flagAddClosingDiv = FALSE;
                $gradeAbbrv = "";
                $CurriculumCOUNTER = 0;

                foreach ($value['curriculum'] as $curriculumArray) {
                    $counter = 0;
                    foreach ($curriculumArray as $a) {
                        $details = "";

                        if ((is_array($a['strand'])) && (array_key_exists('title', $a['strand']))) {
                            $details .= "<div title=\"Strand\" class=\"curr_strand\">
                                                                <div>
                                                                    <span class=\"r_term\">Strand:</span>&nbsp;[STRAND]</div>
                                                            </div>";
                            $details = str_replace("[STRAND]", $a['strand']['title'], $details);
                        }

                        if ((is_array($a['strandunit'])) && (array_key_exists('title', $a['strandunit']))) {
                            $details .= "<div title=\"Strand Unit\" class=\"curr_strand\">
                                                                <div>
                                                                    <span class=\"r_term\">Strand unit:</span>&nbsp;[STRANDUNIT]</div>
                                                            </div>";
                            $details = str_replace("[STRANDUNIT]", $a['strandunit']['title'], $details);
                        }

                        $COdetails = "";
                        if (is_array($a['content_objective'])) {
                            $loopCount = 0;
                            foreach ($a['content_objective'] as $b) {
                                if ((is_array($b)) && (array_key_exists('title', $b))) {
                                    $COdetails .= "<li>" . $b['title'] . "</li>";
                                    $loopCount++;
                                }
                            }
                            if ($loopCount > 0) {
                                $details .= "<div class=\"curr_contentobjective\">
                                                                <div>
                                                                    <span class=\"r_term\">Content objective:</span><br />This resource should enable a child to:</div>
                                                                    [CONTENTOBJECTIVE]
                                                            </div>";

                                $details = str_replace("[CONTENTOBJECTIVE]", "<ul class=\"sr-co-list\">" . $COdetails . "</ul>", $details);
                            }
                        }

                        if ((is_array($a['suggestions_for_use'])) && (array_key_exists('title', $a['suggestions_for_use'])) && (!empty($a['suggestions_for_use']['title']))) {
                            $details .= "<div class=\"curr_suggested_use\">
                                                                <div>
                                                                    <span class=\"r_term\">Suggestions for use:</span>&nbsp;[SUGGESTIONSFORUSE]
                                                                </div>
                                                            </div>";
                            $details = str_replace("[SUGGESTIONSFORUSE]", $a['suggestions_for_use']['title'], $details);
                        }

                        $KSdetails = "";
                        if (is_array($a['key_skills'])) {
                            $loopCount = 0;
                            foreach ($a['key_skills'] as $b) {
                                if ((is_array($b)) && (array_key_exists('title', $b))) {
                                    $KSdetails .= "<li>" . $b['title'] . "</li>";
                                    $loopCount++;
                                }
                            }
                            if ($loopCount > 0) {
                                $details .= "<div class=\"curr_key_skills\">
                                                                <div><span class=\"r_term\">Key Skills:</span></div>
                                                                    [KEYSKILLS]
                                                            </div>";
                                $details = str_replace("[KEYSKILLS]", "<ul class=\"inline-list\">" . $KSdetails . "</ul>", $details);
                            }
                        }

                        if ($a['grade']['abbr'] === $gradeAbbrv) {
                            $detailsOut = $this->str_lreplace("</div>", "", $detailsOut);
                            $details = "<hr>" . $details . "</div>";
                        } else {
                            if ($CurriculumCOUNTER == 0) {
                                $details = "<div class=\"content active\" id=\"panel" . $_loopCount . "-" . $SUBJECTCOUNTER . "-" . $CurriculumCOUNTER . "\">" . $details;
                            } else {
                                $details = "<div class=\"content\" id=\"panel" . $_loopCount . "-" . $SUBJECTCOUNTER . "-" . $CurriculumCOUNTER . "\">" . $details;
                            }
                            $details = $details . "</div>";
                        }

                        $gradeAbbrv = $a['grade']['abbr'];
                        $detailsOut .= $details;
                        $CurriculumCOUNTER++;
                        $counter++;
                    }
                }
                $returnStringTabs = str_replace("[RESOURCEDETAILS]", $detailsOut, $returnStringTabs);
                $returnString .= $returnStringGradeArray . "</div>";
                $returnStringTabs = str_replace("[LEVELS]", $returnStringGradeArrayTabs, $returnStringTabs);
                $SUBJECTCOUNTER++;
            }

            $outString = str_replace("[CUR]", $returnString, $this->curriculumTemplate);
            $tabsOutString = str_replace("[MAPS]", $returnStringTabs, $this->TabsTemplate);
            return array($outString, $tabsOutString);
        }
    }

    function str_lreplace($search, $replace, $subject) {
        $pos = strrpos($subject, $search);
        if ($pos !== false) {
            $subject = substr_replace($subject, $replace, $pos, strlen($search));
        }
        return $subject;
    }

    public function groupCurriculumByGradeAndDiscipline($curriculums) {
        $groupedCurriculum = array();
        foreach ($curriculums as $resourceCurriculum) {

            $discipline = $resourceCurriculum['subject'];
            $grade = $resourceCurriculum['grade'];
            if ($grade !== NULL && $discipline !== null) {
                if (key_exists($discipline['id'], $groupedCurriculum)) {

                    //If grade is not set then set it
                    if (!key_exists($grade['id'], $groupedCurriculum[$discipline['id']]['grade'])) {
                        $groupedCurriculum[$discipline['id']]['grade'][$grade['id']] = $grade;
                    }

                    $groupedCurriculum[$discipline['id']]['curriculum'][$grade['id']][] = $resourceCurriculum;
                } else {
                    $groupedCurriculum[$discipline['id']] = array(
                        'subject' => $discipline,
                        'grade' => array($grade['id'] => $grade),
                        'curriculum' => array($grade['id'] => array($resourceCurriculum))
                    );
                }
            }
        }
        //Reorder Based on grade
        foreach ($groupedCurriculum as &$objArray) {
            ksort($objArray['grade']);
            ksort($objArray['curriculum']);
        }
        return $groupedCurriculum;
    }

    /*
     * 
     * PAGINATION
     * 
     */

    protected $midRange = 4;
    protected $numPages = 0;
    protected $currentPage = 0;
    protected $pageIdentifier = 'sr_page';

    public function paginationFilter($totalPages, $currentPage, $recordsPerPage = 10) {
        if ($totalPages > 0) {
            $this->numPages = ceil($totalPages / $recordsPerPage);
            $this->currentPage = $currentPage;
            $content = '<ul class="sr_pagination sr_right">' . $this->firstPage() . $this->prevPage() . $this->listPages() . $this->nextPage() . $this->lastPage() . '</ul>';
        } else {
            $content = '';
        }

        return $content;
    }

    protected function simplePagination($currentPage, $totalPages, $recordsPerPage = 20) {
        $startPage = $currentPage - $recordsPerPage;
        $endPage = $currentPage + $recordsPerPage;

        if ($startPage <= 0) {
            $endPage -= ($startPage - 1);
            $startPage = 1;
        }

        if ($endPage > $totalPages)
            $endPage = $totalPage;

        if ($startPage > 1)
            echo " First ... ";
        for ($i = $startPage; $i <= $endPage; $i++)
            echo " {$i} ";
        if ($endPage < $totalPage)
            echo " ... Last ";
    }

    protected function prevPage() {
        if ($this->currentPage > 1) {
            $prevPage = ($this->currentPage - 1);
            return '<li><a href="' . $this->generateUrl($prevPage) . '" class="prev">prev</a></li>';
        }
    }

    protected function nextPage() {
        if ($this->currentPage < $this->numPages) {
            $nextPage = $this->currentPage + 1;
            return '<li><a href="' . $this->generateUrl($nextPage) . '" class="next">next</a></li>';
        }
    }

    protected function firstPage() {
        $firstPage = '';
        if ($this->currentPage > ($this->midRange + 1)) {  //  if number of pages between "currentPage" and "firstPage" exceeds $midRange with 1...
            $firstPage .= '<li><a href="' . $this->generateUrl(1) . '" class="first">First Page</a></li>';  //  ...show "first page"-link
            if ($this->currentPage > ($this->midRange + 2)) {   //  if number of pages between $currentPage and "first page" exceeds $midRange with more than 1
                //$firstPage .= '&hellip;';  //  add "..." between "1st page"-link and first page in $range
            }
        }
        return $firstPage;
    }

    protected function lastPage() {
        $lastPage = '';
        if ($this->currentPage < ($this->numPages - $this->midRange)) {  //  if number of pages between "currentPage" and "last page" is equal to $midRange
            if (($this->currentPage < ($this->numPages - $this->midRange) - 1)) {  //  if number of pages between $currentPage and "last page" exceeds $range with more than two
                //$lastPage .= '&hellip;';  //  add "..." between "last page"-link and last page in $range
            }
            $lastPage .= '<li><a href="' . $this->generateUrl($this->numPages) . '" class="last">' . $this->numPages . '</a></li>';   //  show "last page"-link
        }
        return $lastPage;
    }

    #  Range of pages between (prev first ...) and (... last next)

    protected function listPages() {
        $listPages = '';
        for ($i = ($this->currentPage - $this->midRange); $i < (($this->currentPage + $this->midRange) + 1); $i++) {
            if (($i > 0) && ($i <= $this->numPages)) {  //  if page number are within page range
                if ($i == $this->currentPage) {
                    $listPages .= '<li class="sr_current"><a >' . $i . '</a></li>';
                }  //  if we're on current page
                else {
                    $listPages .= '<li><a href="' . $this->generateUrl($i) . '">' . $i . '</a></li>';
                }  //  if not current page
            }
        }
        return $listPages;
    }

    protected function generateUrl($value) {
        $params = $_GET;
        if (key_exists('searchstate', $params)) {
            unset($params['searchstate']);
        }
        $params[$this->pageIdentifier] = $value;
        $paramString = http_build_query($params);

        return $_SERVER['DOCUMENT_URI'] . '?' . $paramString;
    }

}
